//some of the more basic file operations

boolean fexists(String fname)
{
 //File f = new File(sketchPath(fname));
  File f = new File(fname);
  //println(path+" = "+fname);
  if (f.exists())return true;
  return false;
}

void act_loader(String fname)
{
  if(g_map[13]!=C64)return;
  if(fexists(fname)==false)return;
  
  byte actpal[]=loadBytes(fname);
  
  for(int i=0;i<16;i++){
    makecolor(i,int(actpal[i*3]),int(actpal[i*3+1]),int(actpal[i*3+2]));
  }
  
   makecolor(256,0xff,0,0xff);
   makecolor(257,180,180,180);
   g_rgb[257]=0xff808080;
   makecolor(258,0,0,0);
   makecolor(259,48,48,48);
   makecolor(260,255,0,0);
   makecolor(261,0,255,0);
   makecolor(262,0,0,255);
   
   sussborder();
   refresh_all(); 
}

void icon_loader()
{
  for(int i=0;i<88000;i++){
    g_icons[i]=byte(0);
  }
    for (int y=0; y<192; y++) {
      for (int x=0; x<32; x++) {
        int blk=y/64;
        int crow=y/8;
        int yr=y-crow*8;
        int ad=1024+x*8+y*256;
        crow=crow-blk*8;
        int head=blk*2048+crow*32+yr*256+x; 
        if((g_disk[head]&1)==1)g_icons[ad+7]=byte(1);       
        if((g_disk[head]&2)==2)g_icons[ad+6]=byte(1);
        if((g_disk[head]&4)==4)g_icons[ad+5]=byte(1);     
        if((g_disk[head]&8)==8)g_icons[ad+4]=byte(1);
        if((g_disk[head]&16)==16)g_icons[ad+3]=byte(1);      
        if((g_disk[head]&32)==32)g_icons[ad+2]=byte(1);
        if((g_disk[head]&64)==64)g_icons[ad+1]=byte(1);      
        if((g_disk[head]&128)==128)g_icons[ad+0]=byte(1);       
      }
  }
  for(int y=0;y<24;y++){
    for(int x=0;x<32;x++){
      for(int v=0;v<8;v++){
        int ab=g_disk[32*192+x+y*32];
        if(ab==56)ab=1;
        if(ab==7)ab=0;
        g_icons[65536+x+y*256+v*32]=byte(1-ab);
      }
    }
  }
  /*
  if(fexists(dataPath("icons.bin"))==true){
    g_icons=loadBytes(dataPath("icons.bin"));
    return;
  }    
  if(fexists(sketchPath("icons.bin"))==true){
    g_icons=loadBytes(sketchPath("icons.bin"));
    return;
  }
  if(fexists("icons.bin")==true){
    g_icons=loadBytes("icons.bin");
    return;
  }  */
}

void restore(String name, int spared)
{
  //load the picture page g_map[] with parameters
  boolean im_import=false;
  boolean palt_import=false;
  if(fexists(name)==false){
    message("NO FILE");
    return;
  }
  String[] act1 = match(name, ".act");if (act1 != null)palt_import=true;
  String[] act2 = match(name, ".ACT");if (act2 != null)palt_import=true;  
  String[] m1 = match(name, ".png");if (m1 != null)im_import=true;
  String[] m2 = match(name, ".PNG");if (m2 != null)im_import=true;
  String[] m3 = match(name, ".jpg");if (m3 != null)im_import=true;
  String[] m4 = match(name, ".JPG");if (m4 != null)im_import=true;

  if(palt_import){
    act_loader(name);
    message("PALETTE|IMPORTED");
    return;
  }
  
  if(im_import){
      int lefth=g_farge;
      int righth=g_backg;
      storeparameters();g_data['d']=0;g_data['t']=0;g_data['b']=1;//old IQ
      import_image(name);
      restoreparameters();refreshpalette();refresh();
      g_boxreconstruct=2;
      message("Image|loaded");
      selectcolor(0,lefth);selectcolor(1,righth);
      return;
  }
  g_map=loadBytes(name);
  if(g_map[3]!=machine){
    message("Wrong|machine!");
    restore_undo();
    return;
  }
  
  if(spared==0){
    filename=name;
    frame.setTitle(filename);
  }  
  
  if(spared==1){
    sfilename=name;
    frame.setTitle(sfilename);
  }
  
  refreshpalette();
  consistency();
  g_farge=int(g_realfront);
  g_ofarge=g_farge;
  g_backg=int(g_realback);
  sussborder();
  message("Page|loaded");
}

void store(String name)
{
  String[] m1 = match(name, ".png");
  if (m1 != null) {
    if(g_data['Q']==0){export_image_sans_border(name);}
    if(g_data['Q']==1){export_image(name);}
    return;
  }
  
  //save the picture page g_map[], make sure some essential parameters are correct
  g_map[3]=byte(machine);
  g_map[5]=byte(MX);
  g_map[7]=byte(MY);
  saveBytes(name,g_map);
}
